classification
Title: test_httpservers fails
Type: Stage: test needed
Components: Tests, Windows Versions: Python 3.7, Python 3.7
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: neyuru, paul.moore, steve.dower, tim.golden, zach.ware
Priority: normal Keywords:

Created on 2019-01-09 05:01 by neyuru, last changed 2019-01-14 01:20 by neyuru.

Files
File name Uploaded Description Edit
run.txt neyuru, 2019-01-09 05:01 full verbose on rt.bat -x64
failed.txt neyuru, 2019-01-09 05:28 full verbose on rt.bat -x64 -v test_httpservers
Messages (17)
msg333279 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-09 05:01
when running <rt.bat -x64> test_httpservers fails:


0:04:53 [171/407] test_httpservers
E:\RepoGiT\3.6\lib\socket.py:144: ResourceWarning: unclosed <socket.socket [closed] fd=1312, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  _socket.socket.__init__(self, family, type, proto, fileno)
E:\RepoGiT\3.6\lib\test\support\__init__.py:1542: ResourceWarning: unclosed <socket.socket [closed] fd=1988, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  gc.collect()
test test_httpservers failed -- multiple errors occurred; run in verbose mode for details


full run on attached file
msg333286 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2019-01-09 05:23
Try running `rt.bat -x64 -v test_httpservers`, which will run just that test in verbose mode.  If that happens to pass, try `rt.bat -x64 -wW`, which will show the verbose output of a failed test and retry just the failed test at the end of the full run.
msg333287 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-09 05:25
Got it, i'll get back with the results
msg333288 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-09 05:28
The test failed, the results on attached file!
msg333329 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-09 15:50
The thread doesn't display the attachment icon in bugtracker webpage, so I will copy the output here:

E:\RepoGiT\3.6>PCbuild\rt.bat -x64 -v test_httpservers
Deleting .pyc files ...
0 .pyc deleted
Cleaning _pth files ...

E:\RepoGiT\3.6>"E:\RepoGiT\3.6\PCbuild\amd64\python.exe"  -u -Wd -E -bb -m test  -v test_httpservers
== CPython 3.6.8+ (heads/3.6:c2340619a7, Jan 7 2019, 21:35:13) [MSC v.1916 64 bit (AMD64)]
== Windows-10-10.0.17763-SP0 little-endian
== cwd: E:\RepoGiT\3.6\build\test_python_19808
== CPU count: 8
== encodings: locale=cp1252, FS=utf-8
Run tests sequentially
0:00:00 [1/1] test_httpservers
test_err (test.test_httpservers.RequestHandlerLoggingTestCase) ... ok
test_get (test.test_httpservers.RequestHandlerLoggingTestCase) ... ok
test_close_connection (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_date_time_string (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_error (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_header (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_response_only (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_length (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_unbuffered_when_continue (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_html_escape_on_error (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_0_9 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_1_0 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_1_1 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_request_length (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_too_many_headers (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_1_0 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_1_1 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_rejected (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_command (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_error_content_length (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_handler (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_head_via_send_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_header_close (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_header_keep_alive (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_internal_key_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_latin1_header (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_request_line_trimming (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_custom_status (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_explain_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_header_keep_alive (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_send_blank (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_send_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_bogus (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_digits (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_invalid (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_none (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_none_get (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_get (test.test_httpservers.SimpleHTTPServerTestCase) ... FAIL
test_head (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_html_escape_filename (test.test_httpservers.SimpleHTTPServerTestCase) ... skipped 'Can not create file <test&>.txt on current file system'
test_invalid_requests (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_path_without_leading_slash (test.test_httpservers.SimpleHTTPServerTestCase) ... FAIL
test_undecodable_filename (test.test_httpservers.SimpleHTTPServerTestCase) ... skipped 'undecodable name cannot be decoded on win32'
test_authorization (test.test_httpservers.CGIHTTPServerTestCase) ... E:\RepoGiT\3.6\lib\encodings\cp1252.py:21: ResourceWarning: unclosed <socket.socket [closed] fd=992, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  class IncrementalDecoder(codecs.IncrementalDecoder):
E:\RepoGiT\3.6\lib\encodings\cp1252.py:21: ResourceWarning: unclosed <socket.socket [closed] fd=756, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  class IncrementalDecoder(codecs.IncrementalDecoder):
ok
test_headers_and_content (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_invaliduri (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_issue19435 (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_nested_cgi_path_issue21323 (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_no_leading_slash (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_os_environ_is_not_altered (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_post (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_with_continuous_slashes (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_with_multiple_question_mark (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_url_collapse_path (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_urlquote_decoding_in_cgi_check (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_arguments (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_start_with_double_slash (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_windows_colon (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_all (test.test_httpservers.MiscTestCase) ... ok

======================================================================
FAIL: test_get (test.test_httpservers.SimpleHTTPServerTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 408, in test_get
    self.check_status_and_reason(response, HTTPStatus.NOT_FOUND)
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 360, in check_status_and_reason
    self.assertEqual(response.status, status)
AssertionError: 200 != <HTTPStatus.NOT_FOUND: 404>

======================================================================
FAIL: test_path_without_leading_slash (test.test_httpservers.SimpleHTTPServerTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 462, in test_path_without_leading_slash
    self.check_status_and_reason(response, HTTPStatus.NOT_FOUND)
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 360, in check_status_and_reason
    self.assertEqual(response.status, status)
AssertionError: 200 != <HTTPStatus.NOT_FOUND: 404>

----------------------------------------------------------------------

Ran 59 tests in 3.339s

FAILED (failures=2, skipped=2)
test test_httpservers failed
test_httpservers failed

== Tests result: FAILURE ==

1 test failed:
    test_httpservers

Total duration: 3 sec 515 ms
Tests result: FAILURE
About to run again without deleting .pyc first:
Presione una tecla para continuar . . .

E:\RepoGiT\3.6>"E:\RepoGiT\3.6\PCbuild\amd64\python.exe"  -u -Wd -E -bb -m test  -v test_httpservers
== CPython 3.6.8+ (heads/3.6:c2340619a7, Jan 7 2019, 21:35:13) [MSC v.1916 64 bit (AMD64)]
== Windows-10-10.0.17763-SP0 little-endian
== cwd: E:\RepoGiT\3.6\build\test_python_16136
== CPU count: 8
== encodings: locale=cp1252, FS=utf-8
Run tests sequentially
0:00:00 [1/1] test_httpservers
test_err (test.test_httpservers.RequestHandlerLoggingTestCase) ... ok
test_get (test.test_httpservers.RequestHandlerLoggingTestCase) ... ok
test_close_connection (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_date_time_string (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_error (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_header (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_response_only (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_length (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_unbuffered_when_continue (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_html_escape_on_error (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_0_9 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_1_0 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_1_1 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_request_length (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_too_many_headers (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_1_0 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_1_1 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_rejected (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_command (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_error_content_length (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_handler (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_head_via_send_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_header_close (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_header_keep_alive (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_internal_key_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_latin1_header (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_request_line_trimming (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_custom_status (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_explain_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_header_keep_alive (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_send_blank (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_send_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_bogus (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_digits (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_invalid (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_none (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_none_get (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_get (test.test_httpservers.SimpleHTTPServerTestCase) ... FAIL
test_head (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_html_escape_filename (test.test_httpservers.SimpleHTTPServerTestCase) ... skipped 'Can not create file <test&>.txt on current file system'
test_invalid_requests (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_path_without_leading_slash (test.test_httpservers.SimpleHTTPServerTestCase) ... FAIL
test_undecodable_filename (test.test_httpservers.SimpleHTTPServerTestCase) ... skipped 'undecodable name cannot be decoded on win32'
test_authorization (test.test_httpservers.CGIHTTPServerTestCase) ... E:\RepoGiT\3.6\lib\encodings\cp1252.py:21: ResourceWarning: unclosed <socket.socket [closed] fd=996, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  class IncrementalDecoder(codecs.IncrementalDecoder):
E:\RepoGiT\3.6\lib\encodings\cp1252.py:21: ResourceWarning: unclosed <socket.socket [closed] fd=976, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  class IncrementalDecoder(codecs.IncrementalDecoder):
ok
test_headers_and_content (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_invaliduri (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_issue19435 (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_nested_cgi_path_issue21323 (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_no_leading_slash (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_os_environ_is_not_altered (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_post (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_with_continuous_slashes (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_with_multiple_question_mark (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_url_collapse_path (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_urlquote_decoding_in_cgi_check (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_arguments (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_start_with_double_slash (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_windows_colon (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_all (test.test_httpservers.MiscTestCase) ... ok

======================================================================
FAIL: test_get (test.test_httpservers.SimpleHTTPServerTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 408, in test_get
    self.check_status_and_reason(response, HTTPStatus.NOT_FOUND)
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 360, in check_status_and_reason
    self.assertEqual(response.status, status)
AssertionError: 200 != <HTTPStatus.NOT_FOUND: 404>

======================================================================
FAIL: test_path_without_leading_slash (test.test_httpservers.SimpleHTTPServerTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 462, in test_path_without_leading_slash
    self.check_status_and_reason(response, HTTPStatus.NOT_FOUND)
  File "E:\RepoGiT\3.6\lib\test\test_httpservers.py", line 360, in check_status_and_reason
    self.assertEqual(response.status, status)
AssertionError: 200 != <HTTPStatus.NOT_FOUND: 404>

----------------------------------------------------------------------

Ran 59 tests in 3.144s

FAILED (failures=2, skipped=2)
test test_httpservers failed
test_httpservers failed

== Tests result: FAILURE ==

1 test failed:
    test_httpservers

Total duration: 3 sec 297 ms
Tests result: FAILURE
msg333335 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2019-01-09 17:09
No need to paste the output; it's linked between the form at the top and the first message.  It's not shown on the issue list view because it's not a patch.

The next step is to see if it still fails when you build from the `master` branch since 3.6 is now closed to anything but security fixes.  Debugging is likely to be up to you, though; this doesn't happen on any of our CI platforms or on my own machines.  We can give you tips on how to go about that debugging here or via IRC or Zulip, though.
msg333344 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-09 21:03
Ok, thank you. Here are my findings:

steps taken:

1) download today's version of 3.7.2 and 3.8.0 alpha 0
2) navigate to tools/msi
3) run build.bat -x64 (to create amd64 folder under pcbuild)
4) navigate to pcbuild
5) run rt.bat -x64 -v test_httpservers

results:

1) FAILED for 3.7.2 (same as 3.6.8)
2) SUCCESS for 3.8.0 alpha 0

According to PEP-0537 python 3.7.2 is still under bugfixes, so, can I help in something to sort this out?
msg333345 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2019-01-09 21:09
Certainly! Bugfixes, in library or test code, are still welcome on 3.7.
msg333352 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-09 22:45
I have realized that results from rt.bat differ from those when running buildrelease.bat (see example below)
Why do the tests run OK in rt.bat but fail in buildrelase.bat?

To my best understanding, the tests are summoned directly via rt.bat but also from buildrelease.bat (because these are used to generate data for the PGO optimization process right?)- but when run from the buildrelease.bat file, the tests are in "silent" mode, just fatal errors are displayed at the command prompt as opposed to <rt.bat -x64 -wW>.

Is there a way to pass some arguments to buildrelease.bat so that the tests run in verbose mode? This is important, because that way i can know exactly which tests fail.

-----------------------------------------------------------------

EXAMPLE

verbose from <rt.bat -x64 -wW> in test_distutils:
************************************************************************
0:03:57 [113/418] test_distutils
xxmodule.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmpy9gd5kib\Release\Users\yorch\AppData\Local\Temp\tmpy9gd5kib\xx.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmpy9gd5kib\Release\Users\yorch\AppData\Local\Temp\tmpy9gd5kib\xx.cp38-win_amd64.exp
Generando código
Generación de código finalizada
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmpxp_bpi50\tempt\Users\yorch\AppData\Local\Temp\tmpmz5_h8sb\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmpxp_bpi50\tempt\Users\yorch\AppData\Local\Temp\tmpmz5_h8sb\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmpxp_bpi50\tempt\Users\yorch\AppData\Local\Temp\tmpmz5_h8sb\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmpxp_bpi50\tempt\Users\yorch\AppData\Local\Temp\tmpmz5_h8sb\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
xxmodule.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmptd13yi9i\Release\Users\yorch\AppData\Local\Temp\tmptd13yi9i\xx.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmptd13yi9i\Release\Users\yorch\AppData\Local\Temp\tmptd13yi9i\xx.cp38-win_amd64.exp
Generando código
Generación de código finalizada
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmp4ttgsjp5\tempt\Users\yorch\AppData\Local\Temp\tmp1yxs7b6r\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmp4ttgsjp5\tempt\Users\yorch\AppData\Local\Temp\tmp1yxs7b6r\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmp4ttgsjp5\tempt\Users\yorch\AppData\Local\Temp\tmp1yxs7b6r\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmp4ttgsjp5\tempt\Users\yorch\AppData\Local\Temp\tmp1yxs7b6r\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
xxmodule.c
   Creando biblioteca build\temp.win-amd64-3.8\Release\xx.cp38-win_amd64.lib y objeto build\temp.win-amd64-3.8\Release\xx.cp38-win_amd64.exp
Generando código
Generación de código finalizada

E:\RepoGiT\3.8\build\test_python_2512>exit 1

E:\RepoGiT\3.8\build\test_python_2512>exit 0
0:04:41 [114/418] test_docxmlrpc -- test_distutils passed in 44 sec 267 ms
***********************************************************************

verbose from buildrelease.bat -x64 from test_distutils
***********************************************************************
xxmodule.c
E:\RepoGiT\3.8\include\Python.h(8): fatal error C1083: No se puede abrir el archivo incluir: 'pyconfig.h': No such file or directory
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmpwzeadhd1\tempt\Users\yorch\AppData\Local\Temp\tmp196_7v3c\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmpwzeadhd1\tempt\Users\yorch\AppData\Local\Temp\tmp196_7v3c\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmpwzeadhd1\tempt\Users\yorch\AppData\Local\Temp\tmp196_7v3c\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmpwzeadhd1\tempt\Users\yorch\AppData\Local\Temp\tmp196_7v3c\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
xxmodule.c
E:\RepoGiT\3.8\include\Python.h(8): fatal error C1083: No se puede abrir el archivo incluir: 'pyconfig.h': No such file or directory
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmp9093ml9w\tempt\Users\yorch\AppData\Local\Temp\tmpsn45j3j7\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmp9093ml9w\tempt\Users\yorch\AppData\Local\Temp\tmpsn45j3j7\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
foo.c
   Creando biblioteca D:\Users\yorch\AppData\Local\Temp\tmp9093ml9w\tempt\Users\yorch\AppData\Local\Temp\tmpsn45j3j7\foo.cp38-win_amd64.lib y objeto D:\Users\yorch\AppData\Local\Temp\tmp9093ml9w\tempt\Users\yorch\AppData\Local\Temp\tmpsn45j3j7\foo.cp38-win_amd64.exp
Generando código
Generación de código finalizada
xxmodule.c
E:\RepoGiT\3.8\include\Python.h(8): fatal error C1083: No se puede abrir el archivo incluir: 'pyconfig.h': No such file or directory

D:\Users\yorch\AppData\Local\Temp\test_python_4848>exit 1

D:\Users\yorch\AppData\Local\Temp\test_python_4848>exit 0
*********************************************************************
msg333359 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2019-01-10 00:47
The tests mostly fail in the PGO run because they are highly sensitive to the source tree layout. We've never fixed them because they aren't that important to the PGO run - failure cases help with training - and the real tests pass fine under their more controlled conditions.

Don't rely on the PGO run for pass/fails. If you particularly want to fix them, I'd suggest coming up with a (provably) better set of training data, or focusing on running tests from alternate layouts (use the recent PC/layout script to generate sensible layouts in alternate locations).
msg333364 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-10 07:01
Thanks! 

About the alternate set of training data, how (where) do I find it? and about the layouts, can you point me in the right direction as to learn about them, into what they do? or try to achieve? and how to use them?

Quoting Steve Dower ( https://bugs.python.org/issue35299#msg330347 ), the test suite implemented in this project is as good as any other generic workload, which is easily accessible from this repo (I don't know what was he referring to in "ease of accessibility") but I understand it is not the only one out there. So, if there are as many combinations possible as from choosing the tests (the ones implemented here and/or others), why did python choose this in particular? It has to be "good enough" isn't it? and if so, why PGO optimizations where "left out" of the bug tracking loop? It may be not as important in reality, but people like me, crave for optimizations =) 

So, I would love the PGO feature to be revived here, what happened to previous work done here ( https://bugs.python.org/issue26359 )?. But I know also that I am daydreaming. I would appreciate any help, for me to keep digging into it, as I do not know where to start.

thanks!
msg333436 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2019-01-11 04:59
Defining new training sets for PGO would be a new job (that you could volunteer to do if you like). The test suite is convenient because when you clone our GitHub repository, it's already there. Another training suite would have to be installed somehow as part of build (like we already do for extra tools).

The layouts are how Python looks when installed. Currently they are not documented, as they are subject to change (within reason - python.exe has to continue working from the root of any install), but the script in the PC/layout directory can produce them all with different options.

It sounds like these jobs may be more than you want to do. If you are just worried about failing tests during PGO training, then stop worrying because they are known and okay. Provided they pass when Python is installed properly (using our primary installer), there is no problem, and it sounds like this is the case.
msg333437 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-11 05:56
It is true that I worry about failing tests during PGO training because they stop me from compiling Python -with- PGO. I also got here to report my experience and problems back to you guys but, if the problems are known, well, there's nothing much I can do then. Also, I know this isn't a platform for asking howto questions so I will not bother you guys with that either. I *could* get back to topic and try to help sorting out the test_httpservers (because they do fail on 3.7, at least on my side) but it seems I don't have the necessary experience to give any meaningful aid. There's a saying in my hometown which goes something like this: "the one that does not hinder, helps", so that's what I'll do. happy coding!
msg333438 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2019-01-11 06:00
Test failures during the PGO training (*not* those after the final PGO compilation) should be ignored; if they're not, that's an issue that should be fixed.
msg333439 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2019-01-11 06:05
> It is true that I worry about failing tests during PGO training because they stop me from compiling Python -with- PGO.

They shouldn't prevent you from compiling with PGO... even if they cause Python to crash, you should be able to compile still. How is it failing? Do you not get binaries in the output folder at the end? What error messages do you see?

In any case, the httpservers failures seem to recur for you on 3.7, but not anyone else, which means we need your help diagnosing that issue. Could you start by getting the latest 3.7 sources, run "PCbuild/build.bat -p x64" and then your rt.bat command and post the complete output?
msg333543 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-13 04:42
the output is stored on the file run.txt above
msg333578 - (view) Author: Jorge Ramos (neyuru) * Date: 2019-01-14 01:20
E:\RepoGiT\3.7>"E:\RepoGiT\3.7\PCbuild\amd64\python.exe"  -u -Wd -E -bb -m test  -v test_httpservers
== CPython 3.7.2+ (heads/3.7:e1259886ab, Jan 13 2019, 19:16:24) [MSC v.1916 64 bit (AMD64)]
== Windows-10-10.0.17763-SP0 little-endian
== cwd: E:\RepoGiT\3.7\build\test_python_21704
== CPU count: 8
== encodings: locale=cp1252, FS=utf-8
Run tests sequentially
0:00:00 [1/1] test_httpservers
test_err (test.test_httpservers.RequestHandlerLoggingTestCase) ... ok
test_get (test.test_httpservers.RequestHandlerLoggingTestCase) ... ok
test_close_connection (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_date_time_string (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_extra_space (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_error (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_header (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_buffering_of_send_response_only (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_length (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_header_unbuffered_when_continue (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_html_escape_on_error (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_0_9 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_1_0 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_http_1_1 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_request_length (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_too_many_headers (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_1_0 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_1_1 (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_with_continue_rejected (test.test_httpservers.BaseHTTPRequestHandlerTestCase) ... ok
test_command (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_error_content_length (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_handler (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_head_via_send_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_header_close (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_header_keep_alive (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_internal_key_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_latin1_header (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_request_line_trimming (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_custom_status (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_explain_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_return_header_keep_alive (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_send_blank (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_send_error (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_bogus (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_digits (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_invalid (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_none (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_version_none_get (test.test_httpservers.BaseHTTPServerTestCase) ... ok
test_browser_cache (test.test_httpservers.SimpleHTTPServerTestCase)
Check that when a request to /test is sent with the request header ... ok
test_browser_cache_file_changed (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_browser_cache_with_If_None_Match_header (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_get (test.test_httpservers.SimpleHTTPServerTestCase) ... FAIL
test_head (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_html_escape_filename (test.test_httpservers.SimpleHTTPServerTestCase) ... skipped 'Can not create file <test&>.txt on current file system'
test_invalid_requests (test.test_httpservers.SimpleHTTPServerTestCase) ... ok
test_last_modified (test.test_httpservers.SimpleHTTPServerTestCase)
Checks that the datetime returned in Last-Modified response header ... ok
test_path_without_leading_slash (test.test_httpservers.SimpleHTTPServerTestCase) ... E:\RepoGiT\3.7\lib\email\feedparser.py:89: ResourceWarning: unclosed <socket.socket [closed] fd=816, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  for ateof in reversed(self._eofstack):
ResourceWarning: Enable tracemalloc to get the object allocation traceback
FAIL
test_undecodable_filename (test.test_httpservers.SimpleHTTPServerTestCase) ... skipped 'undecodable name cannot be decoded on win32'
test_authorization (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_headers_and_content (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_invaliduri (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_issue19435 (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_nested_cgi_path_issue21323 (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_no_leading_slash (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_os_environ_is_not_altered (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_post (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_with_continuous_slashes (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_with_multiple_question_mark (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_url_collapse_path (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_urlquote_decoding_in_cgi_check (test.test_httpservers.CGIHTTPServerTestCase) ... ok
test_query_arguments (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_start_with_double_slash (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_windows_colon (test.test_httpservers.SimpleHTTPRequestHandlerTestCase) ... ok
test_all (test.test_httpservers.MiscTestCase) ... ok

======================================================================
FAIL: test_get (test.test_httpservers.SimpleHTTPServerTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "E:\RepoGiT\3.7\lib\test\test_httpservers.py", line 422, in test_get
    self.check_status_and_reason(response, HTTPStatus.NOT_FOUND)
  File "E:\RepoGiT\3.7\lib\test\test_httpservers.py", line 374, in check_status_and_reason
    self.assertEqual(response.status, status)
AssertionError: 200 != <HTTPStatus.NOT_FOUND: 404>

======================================================================
FAIL: test_path_without_leading_slash (test.test_httpservers.SimpleHTTPServerTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "E:\RepoGiT\3.7\lib\test\test_httpservers.py", line 523, in test_path_without_leading_slash
    self.check_status_and_reason(response, HTTPStatus.NOT_FOUND)
  File "E:\RepoGiT\3.7\lib\test\test_httpservers.py", line 374, in check_status_and_reason
    self.assertEqual(response.status, status)
AssertionError: 200 != <HTTPStatus.NOT_FOUND: 404>

----------------------------------------------------------------------

Ran 64 tests in 4.182s

FAILED (failures=2, skipped=2)
E:\RepoGiT\3.7\lib\test\support\__init__.py:1539: ResourceWarning: unclosed <socket.socket [closed] fd=732, family=AddressFamily.AF_INET, type=SocketKind.SOCK_STREAM, proto=0>
  gc.collect()
ResourceWarning: Enable tracemalloc to get the object allocation traceback
test test_httpservers failed
test_httpservers failed

== Tests result: FAILURE ==

1 test failed:
    test_httpservers
History
Date User Action Args
2019-01-14 01:20:47neyurusetmessages: + msg333578
versions: Python 3.7, Python 3.7
2019-01-13 04:42:08neyurusetmessages: + msg333543
versions: Python 3.7, Python 3.7
2019-01-11 06:05:19steve.dowersetstatus: closed -> open

stage: resolved -> test needed
messages: + msg333439
versions: - Python 3.6
2019-01-11 06:00:47zach.waresetmessages: + msg333438
versions: Python 3.6, Python 3.7, Python 3.7
2019-01-11 05:58:57neyurusetstatus: open -> closed
stage: test needed -> resolved
versions: Python 3.6, Python 3.7, Python 3.7
2019-01-11 05:56:12neyurusetmessages: + msg333437
versions: Python 3.6, Python 3.7, Python 3.7
2019-01-11 04:59:48steve.dowersetmessages: + msg333436
versions: Python 3.6, Python 3.7, Python 3.7
2019-01-10 07:01:47neyurusetmessages: + msg333364
versions: Python 3.6, Python 3.7, Python 3.7
2019-01-10 00:47:18steve.dowersetmessages: + msg333359
versions: Python 3.6, Python 3.7, Python 3.7
2019-01-09 22:45:07neyurusetmessages: + msg333352
versions: Python 3.6, Python 3.7, Python 3.7
2019-01-09 21:10:01neyurusetversions: + Python 3.6
2019-01-09 21:09:20neyurusetversions: + Python 3.7
2019-01-09 21:09:08zach.waresetstage: test needed
messages: + msg333345
versions: + Python 3.7, - Python 3.6
2019-01-09 21:03:58neyurusetmessages: + msg333344
2019-01-09 17:09:33zach.waresetmessages: + msg333335
2019-01-09 15:50:56neyurusetmessages: + msg333329
2019-01-09 05:28:35neyurusetfiles: + failed.txt

messages: + msg333288
2019-01-09 05:25:12neyurusetmessages: + msg333287
2019-01-09 05:23:00zach.waresetmessages: + msg333286
2019-01-09 05:01:34neyurucreate